routes/web.php
<?php

use App\Http\Controllers\MovieController;
use App\Http\Controllers\AuthController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/login', [AuthController::class, 'showLoginForm'])->name('login');
Route::post('/login', [AuthController::class, 'login']);
Route::post('/logout', [AuthController::class, 'logout'])->name('logout');
Route::get('/register', [AuthController::class, 'showRegistrationForm'])->name('register');
Route::post('/register', [AuthController::class, 'register']);

Route::resource('/movies', MovieController::class)->middleware('auth');

app/Models/Movie.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Movie extends Model
{
    use HasFactory;

    protected $fillable = [
        'title',
        'year',
        'genre',
        'description',
        'active'
    ];
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/Api/MovieController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\Movie;
use Illuminate\Http\Request;

class MovieController extends Controller
{
    public function index(Request $request)
    {
        $request->validate([
            'title' => 'string|max:255',
            'genre' => 'string|max:255',
            'year' => 'integer',
            'year_from' => 'integer',
            'year_to' => 'integer',
            'description' => 'string|max:255',
        ]);

        $movies = Movie::query();

        if ($request->has('title')) {
            $movies->where('title', 'like', '%' . $request->input('title') . '%');
        }

        if ($request->has('genre')) {
            $movies->where('genre', 'like', '%' . $request->input('genre') . '%');
        }

        if ($request->has('year')) {
            $movies->where('year', $request->input('year'));
        }

        if ($request->has('year_from') && $request->has('year_to')) {
            $movies->whereBetween('year', [$request->input('year_from'), $request->input('year_to')]);
        }

        if ($request->has('description')) {
            $movies->where('description', 'like', '%' . $request->input('description') . '%');
        }

        $movies = $movies->paginate(10);

        return response()->json($movies);
    }
}

app/Http/Controllers/AuthController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class AuthController extends Controller
{
    public function showLoginForm()
    {
        return view('auth.login');
    }

    public function login(Request $request)
    {
        $request->validate([
            'email' => 'required|email',
            'password' => 'required|min:8',
        ]);

        $userData = $request->only('email', 'password');

        if (Auth::attempt($userData)) {
            return redirect()->intended('/movies');
        } else {
            return redirect()->back()->withErrors([
                'email' => 'Неправильний email або пароль',
            ]);
        }
    }

    public function logout()
    {
        Auth::logout();
        return redirect('/login');
    }

     public function showRegistrationForm()
    {
        return view('auth.register');
    }

    // Реєстрація нового користувача
    public function register(Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'email' => 'required|string|email|max:255|unique:users',
            'password' => 'required|string|min:8|confirmed',
        ]);

        $user = User::create([
            'name' => $request->name,
            'email' => $request->email,
            'password' => bcrypt($request->password),
        ]);

        Auth::login($user);

        return redirect('/movies');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, ValidatesRequests;
}

app/Http/Controllers/MovieController.php
<?php

namespace App\Http\Controllers;

use App\Models\Movie;
use Illuminate\Http\Request;

class MovieController extends Controller
{
    public function index()
    {
        $movies = Movie::all();
        return view('movies.index', compact('movies'));
    }

    public function create()
    {
        return view('movies.create');
    }

    public function store(Request $request)
    {
        $request->validate([
            'title' => 'string|max:255',
            'genre' => 'string|max:255',
            'year' => 'integer',
            'description' => 'string|max:255',
        ]);

        $movie = new Movie();

        $movie->title =  $request->input('title');
        $movie->year =  $request->input('year');
        $movie->genre =  $request->input('genre');
        $movie->description =  $request->input('description');
        $movie->active =  $request->input('active');

        $movie->save();

        return redirect()->route('movies.index')->with('message', 'Movie added successfully');
    }

    public function edit(string $id)
    {
        $movie = Movie::find($id);
        return view('movies.edit', compact('movie'));
    }

    public function update(Request $request, string $id)
    {
        $request->validate([
            'title' => 'string|max:255',
            'genre' => 'string|max:255',
            'year' => 'integer',
            'description' => 'string|max:255',
        ]);

        $movie = Movie::find($id);

        $movie->title =  $request->input('title');
        $movie->year =  $request->input('year');
        $movie->genre =  $request->input('genre');
        $movie->description =  $request->input('description');
        $movie->active =  $request->input('active');

        $movie->save();

        return redirect()->route('movies.index')->with('message', "movie updated successfully");
    }

    public function destroy(string $id)
    {
        $movie = Movie::find($id);
        $movie->delete();

        return redirect()->route('movies.index')->with('message', 'Movie deleted successfully');
    }
}

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>


    <!-- Scripts -->
    @vite(['resources/sass/app.scss', 'resources/js/app.js'])
</head>
<body>
<div id="app">
    <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
        <div class="container">
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
                    data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav me-auto">

                </ul>

                <ul class="navbar-nav ms-auto">
                    @guest
                        @if (Route::has('login'))
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                        @endif

                        @if (Route::has('register'))
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                            </li>
                        @endif
                    @else
                        <li class="nav-item dropdown">
                            <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button"
                               data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                {{ Auth::user()->name }}
                            </a>

                            <div class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                                <a class="dropdown-item" href="{{ route('logout') }}"
                                   onclick="event.preventDefault();
                                   document.getElementById('logout-form').submit();">
                                    {{ __('Logout') }}
                                </a>

                                <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                    @csrf
                                </form>
                            </div>
                        </li>
                    @endguest
                </ul>
            </div>
        </div>
    </nav>

    <main class="py-4">
        @yield('content')
    </main>
</div>
</body>
</html>

resources/views/movies/create.blade.php
@extends('layouts.app')

@section('content')


    <div class="container p-3">
        <div class="row d-flex justify-content-center">

            <div class="col-md-6 p-3 border">

                <h2>Create movie</h2>

                <form action="{{ route('movies.store') }}" method="post">
                    @method('POST')
                    @csrf

                    <div class="mb-3">
                        <label for="title" class="form-label">Title</label>
                        <input type="text" name="title" id="title" class="form-control">
                    </div>

                    <div class="mb-3">
                        <label for="year" class="form-label">Year</label>
                        <input type="number" id="year" name="year" min="1900" max="2099" placeholder="YYYY">
                    </div>
                    <div class="mb-3">
                        <label for="genre" class="form-label">Genre</label>
                        <input type="text" name="genre" id="genre" class="form-control">
                    </div>
                    <div class="mb-3">
                        <label for="description" class="form-label">Description</label>
                        <input type="text" name="description" id="description" class="form-control">
                    </div>
                    <div class="mb-3">
                        <label for="status" class="form-label">active</label>
                        <select name="active" id="active" class="form-select">
                            <option value="0">Non active</option>
                            <option value="1">Active</option>
                        </select>
                    </div>

                    <button type="submit" class="btn btn-primary">Save</button>

                </form>
            </div>
        </div>
    </div>

@endsection

resources/views/movies/edit.blade.php
@extends('layouts.app')

@section('content')


<div class="container p-3">
    <div class="row d-flex justify-content-center">

        <div class="col-md-6 p-3 border">

            <h2>Edit movie</h2>

            <form action="{{ route('movies.update', $movie) }}" method="post">
                @method('PUT')
                @csrf

                <div class="mb-3">
                    <label for="title" class="form-label">Title</label>
                    <input type="text" name="title" id="title" class="form-control"
                           value="{{ $movie->title }}">
                </div>

                <div class="mb-3">
                    <label for="year" class="form-label">Year</label>
                    <input type="number" id="year" name="year" min="1900" max="2099" placeholder="YYYY"
                           value="{{ $movie->year }}">
                </div>
                <div class="mb-3">
                    <label for="genre" class="form-label">Genre</label>
                    <input type="text" name="genre" id="genre" class="form-control"
                           value="{{ $movie->genre }}">
                </div>
                <div class="mb-3">
                    <label for="description" class="form-label">Description</label>
                    <input type="text" name="description" id="description" class="form-control"
                           value="{{ $movie->description }}">
                </div>
                <div class="mb-3">
                    <label for="status" class="form-label">active</label>
                    <select name="active" id="active" class="form-select">
                        <option value="0" {{ $movie->active == 0 ? 'selected' : '' }}>Non active</option>
                        <option value="1" {{ $movie->active == 1 ? 'selected' : '' }}>Active</option>
                    </select>
                </div>

                <button type="submit" class="btn btn-primary">Save</button>

            </form>
        </div>
    </div>
</div>

@endsection

resources/views/movies/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="col-md-6 text-end">
        <a href="{{ route('movies.create') }}" class="btn btn-primary">Create new</a>
        @if (session('message'))
            <h3 style="color:green">{{ session('message') }}</h3>
        @endif
    </div>

    <div class="container table-responsive py-5">
        <table class="table table-bordered table-hover">
            <thead class="thead-dark">
            <tr>
                <th>Title</th>
                <th>Year</th>
                <th>Genre</th>
                <th>Description</th>
                <th>Active</th>
                <th>Actions</th>
            </tr>
            </thead>
            <tbody>
            @if(isset($movies))
                @foreach($movies as $movie)
                    <tr>
                        <td>{{ $movie->title }}</td>
                        <td>{{ $movie->year }}</td>
                        <td>{{ $movie->genre }}</td>
                        <td>{{ $movie->description }}</td>
                        <td>{{ $movie->active ? 'Active' : 'Inactive' }}</td>
                        <td>
                            <div class="btn-group">
                                <a href="{{ route('movies.edit', $movie->id) }}" class="btn btn-primary ">Edit</a>

                                <form action="{{ route('movies.destroy', $movie->id) }}" method="post"
                                      class="">
                                    @csrf
                                    @method('DELETE')
                                    <button type="submit" class="btn btn-danger">Delete</button>
                                </form>
                            </div>
                        </td>
                    </tr>
                @endforeach
            @endif
            </tbody>
        </table>
    </div>

@endsection